"""
----------------------------------------------------------------------------------------------------
Written by:
  - Yovany Dominico Girón (y.dominico.giron@elprat.cat)

for Ajuntament del Prat de Llobregat
----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------
"""
from abc import ABC, abstractmethod
from typing import Generic, TypeVar

R = TypeVar("R")  # Response from UseCase


class BaseUseCase(ABC, Generic[R]):
    """Base class for use cases"""

    @abstractmethod
    def invoke(self, *params) -> R:
        """Invoke the use case"""
        raise NotImplementedError
